

#include <cstdint>
#include <ctime>
#include <cmath>
#include <cstddef>
#include <cstdlib>
#include <algorithm>
#include "pcc_chrono.h"
#include <iostream>

using namespace std;
using namespace std::chrono;

int main() {

	int32_t num, numSquared, absNum;
	srand(time(NULL));
    pcc::chrono::Stopwatch<std::chrono::steady_clock> clock_timeAbs, clock_timeSquare;		
	
	auto total_wall = 0;
	for (uint32_t i = 0; i < 4294967295; i++) {
				
		num = rand();			
		clock_timeAbs.start();	
		absNum = abs(num);
		clock_timeAbs.stop();
		
		total_wall += duration_cast<milliseconds>(clock_timeAbs.count()).count();		
	}	  
	total_wall = duration_cast<milliseconds>(clock_timeAbs.count()).count();

	cout << "Processing time: " << total_wall / 1000.0 << " s\n";

	total_wall = 0;
	for (uint32_t i = 0; i < 4294967295; i++) {
				
		num = rand();			
		clock_timeSquare.start();	
		numSquared = num*num;
		clock_timeSquare.stop();
		
		total_wall += duration_cast<milliseconds>(clock_timeSquare.count()).count();		
	}	  
	total_wall = duration_cast<milliseconds>(clock_timeSquare.count()).count();

	cout << "Processing time: " << total_wall / 1000.0 << " s\n";

	system("PAUSE");

	return 0;
}